gstreamermm: Gst::PropertyProbe Class Reference

gstreamermm 0.10.10.2

- Main Page
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gst::PropertyProbe Class Reference
gstreamermm Interfaces

An interface for probing possible property values. More...

Inheritance diagram for Gst::PropertyProbe:
[legend]
Collaboration diagram for Gst::PropertyProbe:
[legend]

List of all members.

## Public Member Functions
virtual | ~PropertyProbe ()
GstPropertyProbe* | gobj ()
| Provides access to the underlying C GObject.
const GstPropertyProbe* | gobj () const
| Provides access to the underlying C GObject.
const GList* | get_properties () const
| Get a list of properties for which probing is supported.
const GParamSpec* | get_property (const Glib::ustring& name) const
| Get ParamSpec for a property for which probing is supported.
Glib::ValueArray | get_values (const GParamSpec* pspec) const
| Gets the possible (probed) values for the given property, requires the property to have been probed before.
Glib::ValueArray | get_values (const Glib::ustring& name) const
| Same as get_values().
bool | needs_probe (const GParamSpec* pspec) const
| Checks whether a property needs a probe.
bool | needs_probe (const Glib::ustring& name) const
| Same as needs_probe().
Glib::ValueArray | probe_and_get_values (const GParamSpec* pspec)
| Check whether the given property requires a new probe.
Glib::ValueArray | probe_and_get_values (const Glib::ustring& name)
| Same as probe_and_get_values().
void | probe_property (const GParamSpec* pspec)
| Runs a probe on the property specified by pspec.
void | probe_property (const Glib::ustring& name)
| Runs a probe on the property specified by name.
Glib::SignalProxy1< void, const GParamSpec* > | signal_probe_needed ()
virtual const GList* | get_properties_vfunc () const
virtual bool | needs_probe_vfunc (guint prop_id, const GParamSpec* pspec) const
virtual void | probe_property_vfunc (guint prop_id, const GParamSpec* pspec)
virtual Glib::ValueArray | get_values_vfunc (guint prop_id, const GParamSpec* pspec) const
## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
## Protected Member Functions
| PropertyProbe ()
| You should derive from this class to use it.
virtual void | on_probe_needed (const GParamSpec* pspec)
| This is a default handler for the signal signal_probe_needed().
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::PropertyProbe > | wrap (GstPropertyProbe* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

An interface for probing possible property values.

The property probe is a way to autodetect allowed values for a GObject property. Its primary use is to autodetect device-names in several elements.

The interface is implemented by many hardware sources and sinks.

## Constructor & Destructor Documentation

Gst::PropertyProbe::PropertyProbe | ( |  | ) | `[protected]`

You should derive from this class to use it.

virtual Gst::PropertyProbe::~PropertyProbe | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gst::PropertyProbe::add_interface | ( | GType | gtype_implementer | ) | `[static]`

const GList* Gst::PropertyProbe::get_properties | ( |  | ) | const

Get a list of properties for which probing is supported.

Returns:
  The list of properties for which probing is supported by this element.

virtual const GList* Gst::PropertyProbe::get_properties_vfunc | ( |  | ) | const`[virtual]`

const GParamSpec* Gst::PropertyProbe::get_property | ( | const Glib::ustring & | name | ) | const

Get ParamSpec for a property for which probing is supported.

Parameters:

  name | Name of the property.

Returns:
  The ParamSpec of `0`.

Glib::ValueArray Gst::PropertyProbe::get_values | ( | const GParamSpec * | pspec | ) | const

Gets the possible (probed) values for the given property, requires the property to have been probed before.

Parameters:

  pspec | The ParamSpec property identifier.

Returns:
  A list of valid values for the given property.

Glib::ValueArray Gst::PropertyProbe::get_values | ( | const Glib::ustring & | name | ) | const

Same as get_values().

Parameters:

  name | The name of the property to get values for.

Returns:
  A list of valid values for the given property.

virtual Glib::ValueArray Gst::PropertyProbe::get_values_vfunc | ( | guint | prop_id,
|  | const GParamSpec * | pspec
| ) |  | const`[virtual]`

GstPropertyProbe* Gst::PropertyProbe::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gst::XvImageSink, Gst::AlsaMixer, Gst::AlsaSrc, and Gst::AlsaSink.

const GstPropertyProbe* Gst::PropertyProbe::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gst::XvImageSink, Gst::AlsaMixer, Gst::AlsaSrc, and Gst::AlsaSink.

bool Gst::PropertyProbe::needs_probe | ( | const GParamSpec * | pspec | ) | const

Checks whether a property needs a probe.

This might be because the property wasn't initialized before, or because host setup changed. This might be, for example, because a new device was added, and thus device probing needs to be refreshed to display the new device.

Parameters:

  pspec | A ParamSpec that identifies the property to check.

Returns:
  `true` if the property needs a new probe, `false` if not.

bool Gst::PropertyProbe::needs_probe | ( | const Glib::ustring & | name | ) | const

Same as needs_probe().

Parameters:

  name | The name of the property to check.

Returns:
  `true` if the property needs a new probe, `false` if not.

virtual bool Gst::PropertyProbe::needs_probe_vfunc | ( | guint | prop_id,
|  | const GParamSpec * | pspec
| ) |  | const`[virtual]`

virtual void Gst::PropertyProbe::on_probe_needed | ( | const GParamSpec * | pspec | ) | `[protected, virtual]`

This is a default handler for the signal signal_probe_needed().

Glib::ValueArray Gst::PropertyProbe::probe_and_get_values | ( | const GParamSpec * | pspec | ) |

Check whether the given property requires a new probe.

If so, fo the probe. After that, retrieve a value list. Meant as a utility function that wraps the above functions.

Parameters:

  pspec | The ParamSpec property identifier.

Returns:
  The list of valid values for this property.

Glib::ValueArray Gst::PropertyProbe::probe_and_get_values | ( | const Glib::ustring & | name | ) |

Same as probe_and_get_values().

Parameters:

  name | The name of the property to get values for.

Returns:
  The list of valid values for this property.

void Gst::PropertyProbe::probe_property | ( | const GParamSpec * | pspec | ) |

Runs a probe on the property specified by pspec.

Parameters:

  pspec | ParamSpec of the property.

void Gst::PropertyProbe::probe_property | ( | const Glib::ustring & | name | ) |

Runs a probe on the property specified by name.

Parameters:

  name | Name of the property.

virtual void Gst::PropertyProbe::probe_property_vfunc | ( | guint | prop_id,
|  | const GParamSpec * | pspec
| ) |  | `[virtual]`

Glib::SignalProxy1< void,const GParamSpec* > Gst::PropertyProbe::signal_probe_needed | ( |  | ) |

Slot Prototype:
  `void on_my_probe_needed(const GParamSpec* pspec)`

## Friends And Related Function Documentation

Glib::RefPtr< Gst::PropertyProbe > wrap | ( | GstPropertyProbe * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gstreamermm/propertyprobe.h